#!/usr/bin/perl
# read in the clustering result from enscluster.pl and separate the files into indivual
# directories for CHARMM analysis.  Only hard links created.
#
# cjh, 2006
#

sub usage {
  printf STDERR "usage:    seperate_cluster.pl [-clusterlog log] tag \n";
  exit 1;
}

my $tag;
my $clusterlog = "cluster";

while ($#ARGV>=0) {
  if ($ARGV[0] eq "-clusterlog") {
    shift @ARGV;
    $clusterlog = shift @ARGV;
  } elsif ($ARGV[0] eq "-help" || $ARGV[0] eq "-h") {
    &usage();
  } elsif ($ARGV[0] =~ /^-/) {
    die "unknown option $ARGV[0]";
  } else {
    $tag=shift @ARGV if (!defined $tag);
  }
}

&usage() if (!defined $tag);

open(IN,"<$tag.$clusterlog") || die "Error: can not open cluster output $tag.$clusterlog\n";
my $nl;
my $cid;
my $nc;
my $cnt;
while(<IN>) {
    $nl = $_;
    if($nl =~ /cluster t.(\d+) has (\d+)/) {
	$cid = $1;
	$nc = $2;
	print "Cluster $cid : number of memebers = $nc \n";
	system "mkdir $tag.c$cid";

	for ($cnt=1; $cnt<=$nc; $cnt++) {
	    $nl = <IN>;
	    $nl =~ /(\d+)\s+(\S+)/;
	    system "ln -f $2.gz $tag.c$cid/$cnt.gz";
	}
    }
}

exit; 
